package com.xc.config;

import com.xc.service.InitStockListService;
import com.xc.utils.PropertiesUtil;
import com.xc.utils.websocket.WsClient;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationListener;
import org.springframework.context.event.ContextRefreshedEvent;
import org.springframework.stereotype.Component;

import java.net.URI;
import java.net.URISyntaxException;

@Component
public class ApplicationRunnerImpl implements ApplicationListener<ContextRefreshedEvent> {

    @Autowired
    private InitStockListService initStockListService;


    @Override
    public void onApplicationEvent(ContextRefreshedEvent contextRefreshedEvent) {

        if (contextRefreshedEvent.getApplicationContext().getParent() == null) {
            String url = PropertiesUtil.getProperty("ws.url");
            try {
                WsClient myClient = new WsClient(new URI(url));
                myClient.connect();
                WsClient.getInstance(initStockListService);
                System.out.println("订阅成功555");
            } catch (URISyntaxException e) {
                e.printStackTrace();
            }
        }
    }
}
